/// Ability: Air Dash
// allow you to gain a burst of speed

// CUSTOMIZE SECTION START
local skin = "sonic" // your character here
local airdashspeed = 40 // how fast you want the air dash to go
local airdashheight = 10 // if you don't want the air dash to have any height gain, make this 0
local sound = sfx_cdfm62 // the sound of the double jump
local hasthok = false // if this is true, you will spawn a thok mobj while dashing
local hasghost = true // if this is true, you will have a after image while dashing
local changestate = false // make this true if you want your state to switch to something else
local thestate = S_PLAY_GASP // the state to change to if changestate is true
local ishoming = true // make this true to home into foes while dashing
local homingtime = 350 // the time you will target a foe
// CUSTOMIZE SECTION END PROCCED BELOW IF YOU KNOW WHAT YOUR DOING

addHook("PlayerSpawn", function(player)
    if player.mo and player.mo.skin == skin	
		player.mo.charability = CA_NONE 
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.getheretime == nil
		player.mo.getheretime = 0
	end
	if player.mo and player.mo.skin == skin
	and ishoming == true
		player.thehoming = P_LookForEnemies(player, true, true)
		if player.thehoming and player.thehoming.valid and player.thehoming.health
			P_SpawnLockOn(player, player.thehoming, S_LOCKON1)
		end
	end
	if player.getheretime > 0
	and not P_IsObjectOnGround(player.mo)
	//and player.thehoming and player.thehoming.valid and player.thehoming.health
		P_HomingAttack(player.mo, player.thehoming)
		if hasthok == true
			local thokeffect = P_SpawnThokMobj(player) 
		end
		if hasghost == true
			local ghosteffect = P_SpawnGhostMobj(player.mo) 
			ghosteffect.colorized = true
			ghosteffect.color = player.mo.color
			ghosteffect.fuse = 15
			ghosteffect.blendmode = AST_ADD 
		end
		player.getheretime = $ - 1
	end
	if P_IsObjectOnGround(player.mo)
	or player.powers[pw_carry] == CR_GENERIC
	or player.mo.eflags & MFE_SPRUNG
	or player.mo.eflags & MFE_JUSTHITFLOOR
	or player.exiting
	or not (player.cmd.buttons & BT_JUMP)
	and player.getheretime > 0
		player.getheretime = 0
	end
end)
	
addHook("AbilitySpecial", function(player)
    if player.mo and player.mo.skin == skin
	and not (player.pflags & PF_THOKKED)
		player.pflags = $1|PF_THOKKED
		P_InstaThrust(player.mo, player.mo.angle, FRACUNIT*airdashspeed)
		P_SetObjectMomZ(player.mo,airdashheight*FRACUNIT)
		S_StartSound(player.mo, sound)
		player.mo.state = S_PLAY_TWINSPIN
		if hasthok == true
			local thokeffect = P_SpawnThokMobj(player.mo) 
			thokeffect.colorized = true
			thokeffect.color = player.mo.color
			thokeffect.fuse = 15
			thokeffect.blendmode = AST_ADD 
		end
		if hasghost == true
			local ghosteffect = P_SpawnGhostMobj(player.mo) 
			ghosteffect.colorized = true
			ghosteffect.color = player.mo.color
			ghosteffect.fuse = 15
			ghosteffect.blendmode = AST_ADD 
		end
		if changestate == true
			player.mo.state = thestate
		end
		if ishoming == true
		and player.thehoming and player.thehoming.valid and player.thehoming.health
		and (player.cmd.buttons & BT_JUMP)
			player.getheretime = homingtime
		end
    end
end)

