/// Passive Ability: Health System
// you have a health gauge instead of a ring gauge

// CUSTOMIZE SECTION START
local skin = "tails" // your character here
local maxhealth = 6 // your max health (even numbers suggested!)
local shieldtake = false // if this is true, shield will be taken in exchange for health if you have one
local hitsound = sfx_s3k9b // the sound that will play once your hit
// CUSTOMIZE SECTION END PROCCED BELOW IF YOU KNOW WHAT YOUR DOING

local hpmax = maxhealth
local hp = 0

addHook("PlayerSpawn", function(player)
    if player.mo and player.mo.skin == skin	
		hp = hpmax
		hud.disable("rings")
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == skin
	and hp > hpmax
		hp = 6
	end
end)

addHook("TouchSpecial", function(ring, toucher)
	if toucher and toucher.valid
	and toucher.player.mo.skin == skin then
		P_AddPlayerScore(toucher.player, 100)
		S_StartSound(toucher, sfx_itemup)
		P_SpawnMobj(ring.x, ring.y, ring.z, MT_SPARK)
		P_GivePlayerRings(toucher.player, 1)
		hp = $ + 1
		P_RemoveMobj(ring)
	end
end, MT_RING)


hud.add(function(v,player)
	if player.mo and player.mo.skin == skin
		local xpos = hudinfo[HUD_RINGS].x
		local ypos = hudinfo[HUD_RINGS].y
		if hp > hpmax/2
			v.drawString(xpos, ypos, ("HEALTH: " + (hp) + " / " + (hpmax)), V_PERPLAYER|V_GREENMAP)
		else
			v.drawString(xpos, ypos, ("HEALTH: " + (hp) + " / " + (hpmax)), V_PERPLAYER|V_REDMAP)
		end
	end
end)

addHook("MobjDamage", function(target, inf, src, dmg, dmgType)
	if target.skin == skin and not target.player.powers[pw_super]
		if inf.player
			P_AddPlayerScore(inf.player, 50)
		end
		if target.player.powers[pw_shield]
		and shieldtake == true
			target.player.powers[pw_flashing] = 50
			P_DoPlayerPain(target.player, src, inf)
			S_StartSound(target, hitsound)
			P_RemoveShield(target.player)
		else
			target.player.powers[pw_flashing] = 50
			hp = $ - 1
			P_DoPlayerPain(target.player, src, inf)
			S_StartSound(target, hitsound)
			P_PlayerEmeraldBurst(target.player,false)
			P_PlayerWeaponAmmoBurst(target.player)
			P_PlayerFlagBurst(target.player,false)
			P_PlayerRingBurst(target.player, 10)
			if hp == 0
				P_KillMobj(target,inf,src)
			end
		end
		return true
	end
end, MT_PLAYER)
