/// Ability: Parry
// allows you to block

// CUSTOMIZE SECTION START
local skin = "amy" // your character here
local thebutton = BT_CUSTOM1 // the button needed to do the parry
local sound = sfx_s3k8c // the sound of the parry
local sound2 = 	sfx_bnce1 // blocking sound
local parryframes = 15 // frames of the parry
local parrydelay = 15 // the delay of parrying
local shieldcolor = SKINCOLOR_ROSY // the color of the parry
local thrustspeed = 35 // how far enemies are thrusted
local cooldownhud = true // if this is true, the cooldown will be shown in a heads up display
// CUSTOMIZE SECTION END PROCCED BELOW IF YOU KNOW WHAT YOUR DOING

freeslot("MT_PARRYSHIELD","S_PARRYSHIELD")

mobjinfo[MT_PARRYSHIELD] =
{
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_PARRYSHIELD,
	deathstate = S_PARRYSHIELD,
	xdeathstate = S_PARRYSHIELD,
	radius = 42*FRACUNIT,
	height = 60*FRACUNIT,
	flags = MF_NOGRAVITY
}

states[S_PARRYSHIELD] = {
        sprite = SPR_THOK,
        frame = FF_TRANS50|A,
        tics = 1,
        action = A_CapeChase,
        var1 = 0,
        var2 = 0,
        nextstate = S_PARRYSHIELD
}
hud.add(function(v,player)
	if player.mo and player.mo.skin == skin and player.weapondelay and cooldownhud == true
		local xpos = hudinfo[HUD_LIVES].x
		local ypos = hudinfo[HUD_LIVES].y
		v.drawString(xpos, (ypos - 35), ("COOLDOWN:" + (player.weapondelay)), V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.parrying == nil
		player.mo.parrying = false
	end
	if player.mo.parrytime == nil
		player.mo.parrytime = 0
	end
	if player.mo.parrytime > 0
		player.pflags = $|PF_FULLSTASIS
		player.mo.parrytime = $ - 1
		player.powers[pw_flashing] = TICRATE / 2
		local shield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_PARRYSHIELD)
		shield.target = player.mo
		shield.color = shieldcolor
		shield.scale = player.mo.scale*3/2
		shield.frame = $ |FF_TRANS50
	end
	if player.mo.parrytime == 1
		player.mo.parrytime = 0
		player.mo.parrying = false
		player.pflags = $1 & ~PF_FULLSTASIS
		player.weapondelay = parrydelay
	end
	if player.mo and player.mo.skin == skin
	and (player.cmd.buttons & thebutton)
	and player.mo.parrying == false
	and player.mo.parrytime == 0
	and not player.weapondelay
		S_StartSound(player.mo, sound)
		player.mo.parrytime = parryframes
	end
end)

addHook("MobjThinker", function(shield)
	if (shield.target and shield.target.valid) and (shield.target.parrytime == 0)
		P_RemoveMobj(shield)
	end
end, MT_PARRYSHIELD)

addHook("MobjCollide", function(shield, other)
	if (other.z > shield.z+shield.height) or (shield.z > other.z+other.height) return end
	if (other and other.valid) and (other.flags & MF_ENEMY)
	and shield.parrytime > 0 
		P_InstaThrust(other,shield.angle,FRACUNIT*thrustspeed*2)
		P_SetObjectMomZ(other, 5*FRACUNIT, false)
		S_StartSound(shield, sound2)
		other.target = shield
		other.flags = $&~MF_SPECIAL
		other.flags = $ |MF_GRENADEBOUNCE|MF_MISSILE
	end
	if (other and other.valid) and (other.flags & MF_BOSS)
	and shield.parrytime > 0 
		P_InstaThrust(other,shield.angle,FRACUNIT*thrustspeed)
		P_DamageMobj(other, shield, shield)
		S_StartSound(shield, sound2)
	end
end, MT_PLAYER)